use std::fs;

fn main() -> Result<(), std::io::Error> {
    let input = fs::read_to_string("../data/2015/1/input.txt")?;

    let mut floor = 0;
    for c in input.chars() {
	match c {
	    '(' => { floor += 1 }
	    ')' => { floor -= 1 }
	    _ => { panic!("Invalid character") }
	}
    }
    println!("Part 1: {}", floor);

    floor = 0;
    let mut steps = 0;
    for c in input.chars() {
	match c {
	    '(' => { floor += 1 }
	    ')' => { floor -= 1 }
	    _ => { panic!("Invalid character") }
	}
	steps += 1;
	if floor < 0 { break }
    }
    println!("Part 2: {}", steps);
    Result::Ok(())
}
